void decodedata(FILE *fp,unsigned long buffsize,unsigned char* data,int grpx)
{
   int			i,		j,		k,
			sep,		btm,		idx,
			x,		y,		tmp,
			ix,		iy,		endfg,
			tmpxy,		ptid,		f1;
   unsigned long	badr,		adtmp1,		adtmp2,
			fgbit;
   unsigned char	cb,		cr,		buff[65536];
   static unsigned char	pt2[2][256][2][2],	pt4[2][256][4][4];

   fread(buff,1,buffsize,fp);
   ADR += buffsize;

   sep = buff[9];

   badr = 12;
   btm = 0;
   for (i=0;i<sep;i++)
     {
     adtmp1 = (buff[badr+2 ] << 8 | buff[badr+3 ]) + badr;
     y      = (buff[badr+8 ] << 8 | buff[badr+9 ]) + btm;
     x      =  buff[badr+10] << 8 | buff[badr+11];
     badr  += 12;
     while (adtmp1 > badr)
       {
       idx    =  buff[badr  ] << 8 | buff[badr+1];
       adtmp2 = (buff[badr+2] << 8 | buff[badr+3]) + badr;
       badr  += 4;
       switch (idx)
         {
         case 0x2000:			//printf("2x2 start\n");
                tmp = 0;
                while (adtmp2 > badr && tmp < 256)
                  {
                  cb = buff[badr+4]; cr = buff[badr+5];
                  SetPt2x2(0,tmp,rgb(buff[badr  ],cb,cr),
				rgb(buff[badr+1],cb,cr),
				rgb(buff[badr+2],cb,cr),
				rgb(buff[badr+3],cb,cr));
                  badr += 6;
                  SetPt2x2(1,tmp,pt2[0][tmp][0][0],pt2[0][tmp][1][0],
				 pt2[0][tmp][0][1],pt2[0][tmp][1][1]);
                  tmp++;
                  };
                break;
         case 0x2100:			//printf("2x2\n");
                tmp = 0;
                while (adtmp2 > badr && tmp < 256)
                  {
                  fgbit = buff[badr  ] << 24 | buff[badr+1] << 16
                        | buff[badr+2] << 8  | buff[badr+3];
                  badr += 4;
                  for (j=0;j<32;j++)
                    {
                    if (fgbit & chkbit[j])
                      {
                      cb = buff[badr+4]; cr = buff[badr+5];
                      SetPt2x2(i,tmp,rgb(buff[badr  ],cb,cr),
                                     rgb(buff[badr+1],cb,cr),
                                     rgb(buff[badr+2],cb,cr),
                                     rgb(buff[badr+3],cb,cr));
                      badr += 6;
                      };
                    tmp++;
                    };
                  };
                break;
         case 0x2200:			//printf("4x4 start\n");
                tmp = 0;
                while (adtmp2 > badr && tmp < 256)
                  {
                  cb = buff[badr+4]; cr = buff[badr+5];
                  SetPt4x4(0,tmp,rgb(buff[badr  ],cb,cr),
				 rgb(buff[badr+1],cb,cr),
				 rgb(buff[badr+2],cb,cr),
				 rgb(buff[badr+3],cb,cr));
                  badr += 6;
                  SetPt4x4(1,tmp,pt4[0][tmp][0][0],pt4[0][tmp][2][0],
				 pt4[0][tmp][0][2],pt4[0][tmp][2][2]);
                  tmp++;
                  };
                break;
         case 0x2300:			//printf("4x4\n");
                tmp = 0;
                while (adtmp2 > badr && tmp < 256)
                  {
                  fgbit = buff[badr  ] << 24 | buff[badr+1] << 16 
                        | buff[badr+2] << 8  | buff[badr+3];
                  badr += 4;
                  for (j=0;j<32;j++)
                    {
                    if (fgbit & chkbit[j])
                      {
                      cb = buff[badr+4]; cr = buff[badr+5];
                      SetPt4x4(i,tmp,rgb(buff[badr  ],cb,cr),
				     rgb(buff[badr+1],cb,cr),
				     rgb(buff[badr+2],cb,cr),
				     rgb(buff[badr+3],cb,cr));
                      badr += 6;
                      };
                    tmp++;
                    };
                  };
                break;
         case 0x3000:			//printf("put0\n");
                tmp = 0;
                endfg = 0;
                ix = 0;
                iy = btm * grpx;
                while (adtmp2 > badr && endfg == 0)
                  {
                  fgbit = buff[badr  ] << 24 | buff[badr+1] << 16
                        | buff[badr+2] << 8  | buff[badr+3];
                  badr += 4;
                  for (j=0;j<32;j++)
                    {
                    if (iy > y*grpx) { endfg = 1; break; };
                    tmpxy = ix + iy;
                    if (fgbit & chkbit[j])
                      {
                      ptid = buff[badr++];
                      PutPt2x2(i,ptid,tmpxy,grpx);
                      ptid = buff[badr++];
                      PutPt2x2(i,ptid,tmpxy+2,grpx);
                      ptid = buff[badr++];
                      PutPt2x2(i,ptid,tmpxy+grpx+grpx,grpx);
                      ptid = buff[badr++];
                      PutPt2x2(i,ptid,tmpxy+2+grpx+grpx,grpx);
                      }
                    else
                      {
                      ptid = buff[badr++];
                      PutPt4x4(i,ptid,tmpxy,grpx);
                      };
                    ix += 4; if (ix >= x) { ix = 0; iy += (grpx<<2); };
                    };
                  };
                break;
         case 0x3100:			//printf("put1\n");
                tmp = 0;
                endfg = 0;
                f1 = 0;
                ix = 0;
                iy = btm * grpx;
                while (adtmp2 > badr && endfg == 0)
                  {
                  fgbit = buff[badr  ] << 24 | buff[badr+1] << 16
                        | buff[badr+2] << 8  | buff[badr+3];
                  badr += 4;
                  for (j=0;j<32;j++)
                    {
                    if (iy >= y*grpx) { endfg = 1; break; };
                    tmpxy = ix + iy;
                    if (fgbit & chkbit[j])
                      {
                      if (f1)
                        {
                        ptid = buff[badr++];
                        PutPt2x2(i,ptid,tmpxy,grpx);
                        ptid = buff[badr++];
                        PutPt2x2(i,ptid,tmpxy+2,grpx);
                        ptid = buff[badr++];
                        PutPt2x2(i,ptid,tmpxy+grpx+grpx,grpx);
                        ptid = buff[badr++];
                        PutPt2x2(i,ptid,tmpxy+2+grpx+grpx,grpx);
                        ix += 4; if (ix >=x) { ix = 0; iy += (grpx<<2); };
                        f1 = 0;
                        }
                      else f1 = 1;
                      }
                    else
                      {
                      if (f1)
                        {
                        ptid = buff[badr++];
                        PutPt4x4(i,ptid,tmpxy,grpx);
                        f1 = 0;
                        };
                      ix += 4; if (ix >=x) { ix = 0; iy += (grpx<<2); };
                      };
                    };
                  };
                break;
         case 0x3200:			//printf("put2\n");
                tmp = 0;
                ix = 0;
                iy = btm * grpx;
                while (adtmp2 > badr)
                  {
                  tmpxy = ix + iy;
                  ptid = buff[badr++];
                  PutPt4x4(i,ptid,tmpxy,grpx);
                  ix += 4; if (ix >=x) { ix = 0; iy += (grpx<<2); };
                  };
                break;
         default    :printf("*** pattern index error! ***");
                     printf("[%4x]\n",idx);
         };
       if (adtmp2 != badr) badr = adtmp2;
       };
     btm = y;
     };

};
