//#define NON_CHECK
//#define NEWS_CHECK
#define SUN_CHECK
//#define SOLARIS_CHANGE

/* ******************************************************************** */
/*									*/
/*	ͥѥåץ쥤䡼(եޥå)   for X-Window	*/
/*									*/
/*				Programed by S-II 1995/10/25		*/
/*									*/
/* ********************************************************************	*/

#include <X11/Xlib.h>
#include <X11/Xutil.h>
#include <X11/Xatom.h>
#include <stdio.h>
#include <stdlib.h>
#include <sys/time.h>
#include <sys/file.h>
#include "audiodev.h"
#include "rgbset.h"
#include "pattern.h"
#include "button0.xbm"
#include "button1.xbm"
#include "button2.xbm"
#include "button3.xbm"
#include "button4.xbm"
#include "button5.xbm"
#include "button6.xbm"
#include "button7.xbm"
#include "button8.xbm"


#define FRAME		4096
#define S_OFF		0
#define S_ON		1

unsigned int		SOUND = S_OFF;
unsigned int		SKIP = S_OFF;
unsigned long		ADR;
unsigned long		chkbit[32];

char			*button[] = {button0_bits, button1_bits, button2_bits,
				     button3_bits, button4_bits, button5_bits,
				     button6_bits, button7_bits, button8_bits};

#include "decodegrp.h"

/* ******************************************** */
/* *** ͥѥåإå¤ *****************	*/

struct cinepak_head
{
   int			x,		y,		depth,
			channel,	bit,		rate;
   char			film[5],	ver[5],		fdsc[5],
			cvid[5],	fix1[4],	fix3[6],
			fix2;
};
   			
/* ******************************************** */
/* *** 쥳ɹ¤ *************************	*/

struct record
{
   unsigned long	address,	size;
   long			start,		time;
};


/* ******************************************** */
/* *** ե뤫Υǡɤߤ *********	*/

unsigned long read32(FILE *fp)
{
   unsigned char	chr[4];
   unsigned long	tmp;

   fread(chr,1,4,fp);
   tmp = chr[0] * 0x1000000 + chr[1] * 0x10000
       + chr[2] * 0x100     + chr[3];
   ADR += 4;
   return tmp;
};

unsigned long read16(FILE *fp)
{
   unsigned long	tmp;

   tmp = fgetc(fp) * 0x100 + fgetc(fp);
   ADR += 2;
   return tmp;
};

unsigned char read8(FILE *fp)
{
   ADR++;
   return (unsigned char)(fgetc(fp));
};



/* ******************************************** */
/* *** ᥤ ********************************* */

main(int argv,char** argc)
{
   Display*		dis;
   Visual*		vis;
   Window		win,		dummy1,		dummy2;
   Pixmap		pix,		bitmap;
   GC			gc,		gcw;
   Colormap		cmap;
   XColor		acolor[256];
   XEvent               event;
   XImage		*image,		*image2;
   int			i,		j,		k,
			tmp,		rcdn,		cnt,
			putx,		puty,		loopfg,
			ix,		iy,		mode,
			pintx,		pinty,		sbrate,
			grpx,		grpy,		sbbit,
                        pcmn,		pcm[512],	pcmcnt,
			lank,		volume,		mute,
			ontime,		click,		dpt,
			slider,		sliderhead;
   unsigned int		bitmask;
   long			startcnt,	tcount,		counter,
			startsec,	startusec,	tusec,
			nowsec;
   unsigned long	adtmp1,		header,		buffsize,
			badr;
   unsigned char	data[86400],	data2[7600],	datad,
			sbdata[262144],	buff[262144],	datau;
   struct cinepak_head	head;
   struct record	*rcd;
   struct timeval	tp;
   FILE			*fp;


   printf("\nSATURN-format of Cinepak PLAYER for X-Window Ver 1.00\n\n");

/* ******************************************** */
/* *** ץθ *********************** */

   i = j = 1;
   while (i<argv)
     {
     if (argc[i][0] == '-')
       {
       if (strcmp(argc[i],"-Au")==0) SOUND = S_ON;
       if (strcmp(argc[i],"-Sk")==0) SKIP  = S_ON;
       }
     else if (j == 0)
       {
       printf("Unknown Option.\n");
       fclose(fp);
       exit(1);
       }
     else if (fp=fopen(argc[i],"r")) j = 0;
     i++;
     };
   if (j)
     {
     printf("Set Cinepak file.\n");
     exit(1);
     };
   if (SOUND != S_OFF) SKIP = S_ON;

/* ******************************************** */
/* *** ɥǥХΥץ ************* */

   if (SOUND == S_ON)
     if (device_open())
       {
       SOUND = S_OFF;
       SKIP = S_OFF;
       };

/* ******************************************** */
/* *** åӥåȤκ ******************* */

   for (i=0;i<32;i++)
     chkbit[i] = 0x1 << (31-i);

/* ******************************************** */
/* *** إåɤ߹ *********************** */

   fread(head.film,1,4,fp);
   header  =  fgetc(fp) << 24; header |= (fgetc(fp) << 16);
   header |= (fgetc(fp) << 8); header |=  fgetc(fp);
   fread(head.ver,1,4,fp);
   fread(head.fix1,1,4,fp);
   fread(head.fdsc,1,4,fp);
   fseek(fp,4,1);
   fread(head.cvid,1,4,fp);
   head.y  =  fgetc(fp) << 24; head.y |= (fgetc(fp) << 16);
   head.y |= (fgetc(fp) << 8); head.y |=  fgetc(fp);
   head.x  =  fgetc(fp) << 24; head.x |= (fgetc(fp) << 16);
   head.x |= (fgetc(fp) << 8); head.x |=  fgetc(fp);
   head.depth   = int(fgetc(fp));
   head.channel = int(fgetc(fp));
   head.bit     = int(fgetc(fp));
   head.fix2    = int(fgetc(fp));
   head.rate    = fgetc(fp) << 8; head.rate |= fgetc(fp);
   fread(head.fix3,1,6,fp);
   
   grpx  = head.x;   grpy   = head.y;
   sbbit = head.bit; sbrate = head.rate;
   ADR = 0x30;

   head.film[4] = head.ver[4] = head.fdsc[4] = head.cvid[4] = '\0';
   printf("HEADER: ");
   printf("%4s Ver.%4s [%4s,%4s]\n",head.film,head.ver,head.fdsc,head.cvid);
   printf("  Window size: (%d,%d)\n",grpx,grpy);
   printf("  Color depth: %d bits\n",head.depth);
   printf("  PCM %s / %d bits",(head.channel)?"Monaural":"Stereo",sbbit);
   printf(" ( %d Hz)\n",sbrate);
   

/* ******************************************** */
/* *** ɽν ********************* */

   dis = XOpenDisplay(NULL);
   vis = XDefaultVisual(dis,0);
   win = XCreateSimpleWindow(dis,RootWindow(dis,0),100,100,360,300,0,
				BlackPixel(dis,0),WhitePixel(dis,0));
   XStoreName(dis,win,"Cinepak PLAYER for X-Window");
   dpt = DefaultDepth(dis,0);
   pix = XCreatePixmap(dis,win,360,300,dpt);
   gcw = XCreateGC(dis,win,0,0);
   gc  = XCreateGC(dis,pix,0,0);
   XSelectInput(dis,win,ExposureMask);
   XSetWindowBackgroundPixmap(dis,win,pix);

   cmap = XCreateColormap(dis,RootWindow(dis,0),vis,AllocAll);
   for (i=0;i<8;i++)
     for (j=0;j<8;j++)
       for (k=0;k<4;k++)
         {
         tmp = i*32+j*4+k;
         acolor[tmp].pixel = tmp;
         acolor[tmp].red   = int(i * 9362.1428);
         acolor[tmp].green = int(j * 9362.1428);
         acolor[tmp].blue  = int(k * 21845);
         acolor[tmp].flags = DoRed | DoGreen | DoBlue;
         };
   XStoreColors(dis,cmap,acolor,256);

   image = XCreateImage(dis,vis,dpt,ZPixmap,0,0,grpx,grpy,8,grpx);
   image->data			= (char*)data;
   image->byte_order		= MSBFirst;
   image->bitmap_unit		= 8;
   image->bitmap_bit_order	= MSBFirst;
   image->bits_per_pixel	= 8;
   image->red_mask		= vis->red_mask;
   image->green_mask		= vis->green_mask;
   image->blue_mask		= vis->blue_mask;

   image2 = XCreateImage(dis,vis,dpt,ZPixmap,0,0,360,20,8,360);
   image2->data			= (char*)data2;
   image2->byte_order		= MSBFirst;
   image2->bitmap_unit		= 8;
   image2->bitmap_bit_order	= MSBFirst;
   image2->bits_per_pixel	= 8;
   image2->red_mask		= vis->red_mask;
   image2->green_mask		= vis->green_mask;
   image2->blue_mask		= vis->blue_mask;

   XMapWindow(dis,win);
   XFlush(dis);
   while(1)
     {
     XNextEvent(dis,&event);
     if(event.xexpose.count == 0) break;
     };
   XInstallColormap(dis,cmap);
   XSetWindowColormap(dis,win,cmap);
   XFlush(dis);

   putx = int((360 - grpx) / 2);
   puty = int((240 - grpy) / 2);

/* ******************************************** */
/* *** ̤ι *****************************	*/

   XSetForeground(dis,gc,0);
   XFillRectangle(dis,pix,gc,0,0,360,240);
   XSetForeground(dis,gc,4*32+4*4+2);
   XFillRectangle(dis,pix,gc,0,240,360,300);
   j = 40; k = 240;
   for (i=0;i<9;i++)
     {
     XSetForeground(dis,gc,0);
     XDrawRectangle(dis,pix,gc,i*j,k,j-1,j-1);
     XSetForeground(dis,gc,6*32+6*4+3);
     XDrawRectangle(dis,pix,gc,i*j+1,k+1,j-5,j-5);
     XSetForeground(dis,gc,2*32+2*4+1);
     XDrawRectangle(dis,pix,gc,i*j+3,k+3,j-5,j-5);
     XSetForeground(dis,gc,4*32+4*4+2);
     XFillRectangle(dis,pix,gc,i*j+2,k+2,j-5,j-5);
     bitmap = XCreatePixmapFromBitmapData(dis,win,button[i],
		button0_width,button0_height,0,4*32+4*4+2,dpt);
     XCopyArea(dis,bitmap,pix,gc,0,0,button0_width,button0_height,i*j+8,k+8);
     XFreePixmap(dis,bitmap);
     };
   if (SOUND == S_OFF)
     {
     XSetForeground(dis,gc,255);
     XSetFunction(dis,gc,GXxor);
     XFillRectangle(dis,pix,gc,200,240,119,39);
     XSetFunction(dis,gc,GXcopy);
     };
   XClearWindow(dis,win);

   for (i=0;i<360*20;i++) data2[i] = 4*32+4*4+2;
   for (i=5;i<15;i++) for (j=5;j<305+4;j++) data2[j+i*360] = 0;
   sliderhead = 360*6+5;
   for (i=5;i<15;i++) for (j=324;j<352;j++) data2[j+i*360] = 0;

   XFlush(dis);

/* ******************************************** */
/* *** ɥǥХ ***************** */

   if (SOUND == S_ON)
     device_start(head.rate,head.channel,head.bit);

/* ******************************************** */
/* *** ơ֥ɤ߹ *************** */

   printf("TIME TABLE: ");
     for (i=0;i<4;i++) printf("%c",read8(fp));
     read32(fp);
   printf("\n  Time counter: 1/");
     tcount = read32(fp);
     tusec = long(1000000 / tcount);
     printf("%d ( %d usec)\n",tcount,tusec);
   printf("  Total records:");
     printf("%d\n",adtmp1 = read32(fp));

   if (rcd =
     (struct record *)malloc((unsigned int)((adtmp1+1)*sizeof(struct record))))
     {

   rcdn = pcmn = 0;
   while (ADR < header)
     {
     rcd[rcdn].address = read32(fp) + header;
     rcd[rcdn].size    = read32(fp);
     rcd[rcdn].start   = read32(fp);
     rcd[rcdn].time    = read32(fp);

     if (rcd[rcdn].start == 0) startcnt = rcdn;
//   printf("  RECORD[%3d]%8xh[%8x]",rcdn,rcd[rcdn].address,rcd[rcdn].start);
     if (rcd[rcdn].start == 0xffffffff)
       {
       pcm[pcmn++] = rcdn;
//     printf(" : PCM DATA\n");
       }
     else
       {
       startsec       = rcd[rcdn].start & 0x7fffffff;
       rcd[rcdn].time = (startsec % tcount) * tusec;
       startsec       = startsec / tcount;
//     printf(" : start %4d.%6d\n",startsec,rcd[rcdn].time);
       rcd[rcdn].time += startsec * 1000000;
       if (rcd[rcdn].start & 0x80000000) rcd[rcdn].start = 1;
         else                            rcd[rcdn].start = 0;
       };
     rcdn++;
     };

/* ******************************************** */
/* *** ׻ ********************************* */

   makeCbCr();
   if (SKIP == 0)
     {
     gettimeofday(&tp,NULL);
     startsec = tp.tv_sec*1000000 + tp.tv_usec;
     };


/* ******************************************** */
/* *** ǡɤ߹߳ ******************* */

   volume = 80;
   slider = sliderhead;
   PutSlider(slider);
   for (i=0;i<=volume;i+=10) PutVolume(i);
   XPutImage(dis,win,gc,image2,0,0,0,280,360,20);
   click = 0;
   mute = SOUND;
   ontime = SKIP;
   mode = 0;
   cnt = pcmcnt = 0;
   nowsec = 0;
   loopfg = 1;
   while (loopfg >= 0)
     {

/* ******************************************** */
/* *** 󥿥եʬ *********************	*/

     do{
       if (loopfg == 2)
         {
         loopfg = 1;
         if (mode == 0) cnt = pcmcnt = 0;
         };
       XQueryPointer(dis,win,&dummy1,&dummy2,&ix,&iy,&pintx,&pinty,&bitmask);
       if (bitmask & 0x100)
         {
         if (240 < pinty && pinty < 280)
           {
           if (!click)
             {
             switch (mode = int(pintx/40))
               {
               case 0:loopfg = 2; cnt = startcnt; break;
               case 1:loopfg = 0; break;
               case 2:loopfg = 2; cnt--;
                     if (cnt <= 0) { cnt = rcdn-1; pcmcnt = pcmn-1; break; };
                     if (rcd[cnt].start == 0xffffffff)
                       { cnt--; pcmcnt--; }; break;
               case 3:loopfg = 1; break;
               case 4:loopfg = 2; cnt++; break;
               case 5:if (SOUND == S_OFF) break;
                      NotVolume(volume);
                      volume -= 10; if (volume < 0  ) volume = 0;
                      device_volume(volume); break;
               case 6:if (SOUND == S_OFF) break;
                      volume += 10; if (volume > 250) volume = 250;
                      PutVolume(volume);
                      device_volume(volume); break;
               case 7:if (SOUND == S_OFF) break;
                      mute = 1 - mute;
                      if (mute) ontime = SKIP;
                        else    ontime = 0;
                      break;
               case 8:loopfg = -1; break;
               };
             if (loopfg > 0) device_stop();
             if (mode == 5 || mode == 6)
               XPutImage(dis,win,gc,image2,0,0,0,280,360,20);
             if (SOUND == S_ON || (SOUND == S_OFF && (mode < 5 || mode == 8)))
               {
               XSetForeground(dis,gcw,255); XSetFunction(dis,gcw,GXxor);
               XFillRectangle(dis,win,gcw,mode*40,240,39,39);
               XSetFunction(dis,gcw,GXcopy);
               XFlush(dis);
               if (mode < 3 || mode == 4 || mode == 7)
                 {
                 if (mode == 2) { FillData; };
                 fseek(fp,rcd[cnt].address-ADR,1);
                 ADR = rcd[cnt].address;
                 SetNowTime;
                 };
               };
             click = 1;
             };
           }
         else if (280 < pinty && pinty < 300 && 5 < pintx && pintx < 306)
           {
           if (!click)
             {
             cnt = int((pintx - 6)*rcdn/300);
             if (cnt >= rcdn) cnt = rcdn -1;
             pcmcnt = 0;
             for (i=0;i<cnt;i++) if (rcd[i].start == 0xffffffff) pcmcnt++;
             NotSlider(slider);
             slider = int(300*cnt/rcdn) + sliderhead;
             PutSlider(slider);
             XPutImage(dis,win,gc,image2,0,0,0,280,360,20);
             XFlush(dis);
             FillData;
             SetNowTime;
             click = 2;
             };
           };
         }
       else if (click)
         {
         if ((click == 1 && mode != 7 ) && (SOUND == S_ON ||
             (SOUND == S_OFF && (mode < 5 || mode == 8))))
           {
           XSetForeground(dis,gcw,255); XSetFunction(dis,gcw,GXxor);
           XFillRectangle(dis,win,gcw,mode*40,240,39,39);
           XSetFunction(dis,gcw,GXcopy);
           };
         click = 0;
         };
       } while (loopfg == 1 && click != 2);

/* ******************************************** */
/* *** ȤƱ *************************** */

     if (ontime && (pcmcnt > 0) && !loopfg)
       {
       if ((pcmcnt < pcmn) && (rcd[pcm[pcmcnt]+1].time < nowsec))
         {
         cnt = pcm[pcmcnt];
         fseek(fp,rcd[cnt].address-ADR,1);
         ADR = rcd[cnt].address;
         };
       };

/* ******************************************** */
/* *** 饤 ************************* */

     NotSlider(slider);
     slider = int(300*cnt/rcdn) + sliderhead;
     PutSlider(slider);
     XPutImage(dis,win,gc,image2,0,0,0,280,360,20);

/* ******************************************** */
/* *** ǡɤ߹ ******************* */

     if (rcd[cnt].start == 0xffffffff)
       {
       if (mute && !loopfg)
         {
         fread(buff,1,rcd[cnt].size,fp);
         j = k = 0;
         if (sbbit == 16)
           {
           while (j<rcd[cnt].size)
             {
             while (lank >= 0)
               {
               datau = buff[j++];
               datad = buff[j++];
               lank -= RATE;
               };
             while (lank < 0)
               {
               sbdata[k++] = datau;
               sbdata[k++] = datad;
               lank += sbrate;
               };
             };
           }
         else
           {
           while (j<rcd[cnt].size)
             {
             while (lank >= 0)
               {
               datau = buff[j++];
               lank -= RATE;
               };
             while (lank < 0)
               {
               sbdata[k++] = datau;
               lank += sbrate;
               };
             };
           };
//       device_wait();
         device_play(sbdata,k);
         }
       else fseek(fp,rcd[cnt].size,1);
       ADR += rcd[cnt].size;
       pcmcnt++;
       }

/* ******************************************** */
/* *** ǡɤ߹ ******************* */

     else
       {
       decodedata(fp,rcd[cnt].size,data,grpx);


/* ******************************************** */
/* *** ߥĴ ************************* */

       if (ontime && !loopfg)
         do{
           gettimeofday(&tp,NULL);
           if (cnt == startcnt)
             {
             startsec = tp.tv_sec*1000000 + tp.tv_usec;
             };
           nowsec = tp.tv_sec*1000000 + tp.tv_usec - startsec;
           } while (nowsec <  rcd[cnt].time);

/* ******************************************** */
/* *** ̤ؤν *************************** */

       XPutImage(dis,win,gc,image,0,0,putx,puty,grpx,grpy);
       XFlush(dis);
       };
     if (!loopfg) cnt ++;
     if (cnt == rcdn)
       {
       if (SOUND == S_ON) device_stop();
       cnt = pcmcnt = 0;
       fseek(fp,rcd[cnt].address-ADR,1);
       ADR = rcd[cnt].address;
       nowsec = 0;
       };
     };

/* ******************************************** */
/* *** λ *********************************** */

   if (SKIP == 0)
     {
     gettimeofday(&tp,NULL);
     nowsec = tp.tv_sec*1000000 + tp.tv_usec - startsec;
     };
   printf("Finished. Total time = %d usec\n",nowsec);

   free(rcd);
   } else printf("Not get enough memory(MAX %d frame).\n",FRAME);

   fclose(fp);
   if (SOUND == S_ON) device_close();

   XUninstallColormap(dis,cmap);
   XDestroyImage(image2);
   XDestroyImage(image);
   XFreeColormap(dis,cmap);
   XFreeGC(dis,gc);
   XFreeGC(dis,gcw);
   XFreePixmap(dis,pix);
   XDestroyWindow(dis,win);
};
